Merge "Expose hazelcast cluster info"
[cps.git] / test-tools / test-deregistration.sh
1 #!/bin/bash
2 #
3 # Copyright 2023 Nordix Foundation.
4 #
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16 #
17
18 set -o errexit  # Exit on most errors
19 set -o nounset  # Disallow expansion of unset variables
20 set -o pipefail # Use last non-zero exit code in a pipeline
21 #set -o xtrace   # Uncomment for debugging
22
23 GRAB_METRICS=true
24 DOCKER_COMPOSE_FILE=../docker-compose/docker-compose.yml
25 CREATE_REQUEST=/tmp/cmhandles-create-req.txt
26 REMOVE_REQUEST=/tmp/cmhandles-remove-req.txt
27 REPORT_FILE=./metrics-reports/deregister-summary-$(date --iso-8601=seconds).tsv
28 SCRIPT_DIR=$(dirname -- "${BASH_SOURCE[0]}")
29
30 stop_docker() {
31     docker-compose -f $DOCKER_COMPOSE_FILE --profile dmi-stub --profile monitoring down >/dev/null
32     docker container prune -f >/dev/null
33     docker volume prune -f >/dev/null
34 }
35
36 restart_docker() {
37     stop_docker
38     docker-compose -f $DOCKER_COMPOSE_FILE --profile dmi-stub --profile monitoring up -d >/dev/null
39 }
40
41 wait_for_cps_to_start() {
42     docker logs cps-and-ncmp -f | grep -m 1 'Started Application' >/dev/null || true
43 }
44
45 get_number_of_handles_ready() {
46     PGPASSWORD=cps psql -h localhost -p 5432 cpsdb cps -c \
47         "SELECT count(*) FROM public.fragment where attributes @> '{\"cm-handle-state\": \"READY\"}';" \
48         | sed '3!d' | sed 's/ *//'
49 }
50
51 wait_for_handles_to_be_ready() {
52     local TOTAL_HANDLES=$1
53     local HANDLES_READY=0
54     while [ "$HANDLES_READY" -lt "$TOTAL_HANDLES" ]; do
55         sleep 10
56         HANDLES_READY=$(get_number_of_handles_ready)
57         echo "There are $HANDLES_READY CM handles in READY state."
58     done
59 }
60
61 create_handles() {
62     curl --fail --silent --show-error \
63         --location 'http://localhost:8883/ncmpInventory/v1/ch' \
64         --header 'Authorization: Basic Y3BzdXNlcjpjcHNyMGNrcyE=' \
65         --header 'Content-Type: application/json' \
66         --data @$CREATE_REQUEST
67 }
68
69 remove_handles_and_record_time() {
70     curl --fail --silent --show-error --output /dev/null --write-out '%{time_total}\n' \
71         --location 'http://localhost:8883/ncmpInventory/v1/ch' \
72         --header 'Authorization: Basic Y3BzdXNlcjpjcHNyMGNrcyE=' \
73         --header 'Content-Type: application/json' \
74         --data @$REMOVE_REQUEST >> "$REPORT_FILE"
75 }
76
77 create_request_bodies() {
78     local CREATE_SIZE=$1
79     local REMOVE_SIZE=$2
80     echo -n '{"dmiPlugin": "http://ncmp-dmi-plugin-demo-and-csit-stub:8092","createdCmHandles":[' > $CREATE_REQUEST
81     echo -n '{"dmiPlugin": "http://ncmp-dmi-plugin-demo-and-csit-stub:8092","removedCmHandles":[' > $REMOVE_REQUEST
82     for i in $(seq 1 "$CREATE_SIZE"); do
83         local CMHANDLE
84         CMHANDLE=$(uuidgen | tr -d '-')
85         echo -n "{\"cmHandle\": \"$CMHANDLE\",\"cmHandleProperties\":{\"neType\":\"RadioNode\"}}" \
86             >> $CREATE_REQUEST
87         if [ "$i" -lt "$CREATE_SIZE" ]; then
88             echo -n "," >> $CREATE_REQUEST
89         fi
90         if [ "$i" -le "$REMOVE_SIZE" ]; then
91             echo -n "\"$CMHANDLE\"" >> $REMOVE_REQUEST
92         fi
93         if [ "$i" -lt "$REMOVE_SIZE" ]; then
94             echo -n "," >> $REMOVE_REQUEST
95         fi
96     done
97     echo ']}' >> $CREATE_REQUEST
98     echo ']}' >> $REMOVE_REQUEST
99 }
100
101 test_deregistration() {
102     local REMOVE_SIZE=$1
103     local CREATE_SIZE=$2
104
105     echo "Testing deregistration of $REMOVE_SIZE out of $CREATE_SIZE CM handles"
106
107     echo "Restarting docker"
108     restart_docker
109     echo "Waiting for CPS to start"
110     wait_for_cps_to_start
111
112     echo "Creating request bodies"
113     create_request_bodies "$CREATE_SIZE" "$REMOVE_SIZE"
114
115     echo "[$(date --iso-8601=seconds)] Creating CM handles"
116     create_handles
117     echo "Waiting for CM handles to be in READY state"
118     wait_for_handles_to_be_ready "$CREATE_SIZE"
119
120     if [ "$GRAB_METRICS" = "true" ]; then
121         echo "Grabbing metrics before deregistration"
122         METRICS_BEFORE=$(./generate-metrics-report.sh)
123     fi
124
125     echo "[$(date --iso-8601=seconds)] Removing CM handles"
126     echo -e -n "$REMOVE_SIZE\t$CREATE_SIZE\t" >> "$REPORT_FILE"
127     remove_handles_and_record_time
128     echo "There are $(get_number_of_handles_ready) CM handles still in READY state."
129
130     if [ "$GRAB_METRICS" = "true" ]; then
131         echo "Grabbing metrics after deregistration"
132         METRICS_AFTER=$(./generate-metrics-report.sh)
133         echo "Generating metrics report"
134         ./subtract-metrics-reports.py -a "$METRICS_AFTER" -b "$METRICS_BEFORE" \
135             -o "metrics-reports/deregister-$(date --iso-8601=seconds)-$REMOVE_SIZE-$CREATE_SIZE.tsv"
136         rm "$METRICS_BEFORE" "$METRICS_AFTER"
137     fi
138
139     echo
140 }
141
142 cleanup() {
143     rm -f "$CREATE_REQUEST" "$REMOVE_REQUEST"
144     stop_docker
145     cat "$REPORT_FILE"
146     popd
147 }
148 trap cleanup EXIT
149
150 pushd -- "$SCRIPT_DIR"
151
152 mkdir -p "$(dirname "$REPORT_FILE")"
153 echo -e "Removed\tTotal\tTime" > "$REPORT_FILE"
154
155 for number_to_delete in 100 500 1000 5000 10000 20000; do
156     test_deregistration $number_to_delete $number_to_delete
157 done